CLASS zcl_material_stock_jb DEFINITION
  PUBLIC
  FINAL
  CREATE PUBLIC .

  PUBLIC SECTION.
    INTERFACES if_rap_query_provider.
  PROTECTED SECTION.
  PRIVATE SECTION.
ENDCLASS.



CLASS ZCL_MATERIAL_STOCK_JB IMPLEMENTATION.


  METHOD if_rap_query_provider~select.
    TRY.
        TRY.
            "IF io_request->is_data_requested(  ).
            "io_request->get_paging( ).
            DATA: rt_plant   TYPE RANGE OF werks_D,
                  rt_product TYPE RANGE OF matnr.
            DATA(lo_paging) = io_request->get_paging( ).
            DATA(lv_skip) = io_request->get_paging( )->get_offset(  ).
            DATA(lv_top) = io_request->get_paging( )->get_page_size(  ).
            DATA(lt_sort_elements) = io_request->get_sort_elements( ) .
            DATA(lt_ranges) = io_request->get_filter( )->get_as_ranges( )."Basic search term
            DATA(lt_filter_cond) = io_request->get_parameters( ). "setting the filter condition, fetching parameter names from data definition

            LOOP AT lt_ranges REFERENCE INTO DATA(lr_range).
              CASE lr_range->name.
                WHEN 'PLANT'.
                  LOOP AT lr_range->range REFERENCE INTO DATA(lr_range_entry).
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE RT_plant.
                  ENDLOOP.
                WHEN 'PRODUCT'.
                  LOOP AT lr_range->range REFERENCE INTO lr_range_entry.
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE rt_product.
                  ENDLOOP.
              ENDCASE.
            ENDLOOP.

            DATA:lt_table     TYPE STANDARD TABLE OF zcv_jbkc,
                 lt_table_out TYPE STANDARD TABLE OF zcv_jbkc,
                 ls_table     TYPE zcv_jbkc.
            TRY.
                SELECT *
                  FROM I_StockQuantityCurrentValue_2( P_DisplayCurrency = 'CNY' )
                  WHERE product IN @rt_product
                  AND plant IN @rt_plant
                  INTO TABLE @DATA(lt_stock).
                DATA(lt_stock01) = lt_stock.
                SORT lt_stock01 BY product plant StorageLocation.
                DELETE ADJACENT DUPLICATES FROM lt_stock01 COMPARING product plant StorageLocation.
                IF lt_stock01 IS NOT INITIAL.
                  SELECT *
                      FROM I_ProductDescription
                      FOR ALL ENTRIES IN @lt_stock01
                      WHERE product = @lt_stock01-product
                      AND Language EQ '1'
                      INTO TABLE @DATA(lt_makt).
                  SORT lt_makt BY product.
                ENDIF.
                LOOP AT lt_stock01 INTO DATA(ls_stock01).
                  MOVE-CORRESPONDING ls_stock01 TO ls_table.
                  LOOP AT lt_stock INTO DATA(ls_stock) WHERE product = ls_stock01-product AND plant = ls_stock01-plant AND StorageLocation = ls_stock01-StorageLocation.
                    "非限制数量
                    IF ls_stock-ValuationAreaType EQ '1' AND ls_stock-InventoryStockType EQ '01' AND ls_stock-InventorySpecialStockType IS INITIAL.
                      ls_table-fxzQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-fxzQuantity.
                    ENDIF.
                    "质量检验数量
                    IF ls_stock-ValuationAreaType EQ '1' AND ls_stock-InventoryStockType EQ '02' AND ls_stock-InventorySpecialStockType IS INITIAL.
                      ls_table-zljyQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-zljyQuantity.
                    ENDIF.
                    "客户库存数量
                    IF ls_stock-ValuationAreaType EQ '1' AND ls_stock-InventoryStockType EQ '01' AND ls_stock-InventorySpecialStockType EQ 'W'.
                      ls_table-khkcQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-khkcQuantity.
                    ENDIF.
                    "委外库存数量
                    IF ls_stock-ValuationAreaType EQ '1' AND ls_stock-InventoryStockType EQ '01' AND ls_stock-InventorySpecialStockType EQ 'O'.
                      ls_table-wwkcQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-wwkcQuantity.
                    ENDIF.
                    CLEAR ls_stock.
                  ENDLOOP.
                  "-物料描述
                  READ TABLE lt_makt INTO DATA(ls_makt) WITH KEY product = ls_stock01-product BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    ls_table-maktx = ls_makt-ProductDescription.
                    CLEAR ls_makt.
                  ENDIF.
                  APPEND ls_table TO lt_table.
                  CLEAR:ls_stock01,ls_table.
                ENDLOOP.
              CATCH cx_sy_dynamic_osql_syntax INTO DATA(lx_data). " exception to catch and manage dynamic query errors . must use this in order to work properly
            ENDTRY.
            "lo_response->get_business_data( IMPORTING et_business_data = lt_table ).
*            DATA lv_lines TYPE int8.
*            lv_lines = lines( lt_table ).
            DATA(lv_start) = lv_skip + 1.
            IF lv_top <= 0.
              lv_top = 50.
            ENDIF.
            DATA(lv_end) = lv_skip + lv_top.

            APPEND LINES OF lt_table FROM lv_start TO lv_end TO lt_table_out.

            io_response->set_total_number_of_records( lines( lt_table ) ).
            io_response->set_data( lt_table_out ).
            "io_response->set_total_number_of_records( lines( lt_table  ) ).
            "ENDIF.
          CATCH  cx_rap_query_provider INTO DATA(lx_exc).
        ENDTRY.
      CATCH cx_rfc_dest_provider_error INTO DATA(lx_dest).
    ENDTRY.
  ENDMETHOD.
ENDCLASS.
