CLASS zcl_material_stock_sum DEFINITION
  PUBLIC
  FINAL
  CREATE PUBLIC .

  PUBLIC SECTION.
    INTERFACES if_rap_query_provider.
  PROTECTED SECTION.
  PRIVATE SECTION.
ENDCLASS.



CLASS ZCL_MATERIAL_STOCK_SUM IMPLEMENTATION.


  METHOD if_rap_query_provider~select.
    TRY.
        TRY.
            "IF io_request->is_data_requested(  ).
            "io_request->get_paging( ).
            DATA: rt_plant       TYPE RANGE OF werks_D,
                  rt_product     TYPE RANGE OF matnr,
                  rt_SoldToParty TYPE RANGE OF char10.
            DATA(lo_paging) = io_request->get_paging( ).
            DATA(lv_skip) = io_request->get_paging( )->get_offset(  ).
            DATA(lv_top) = io_request->get_paging( )->get_page_size(  ).
            DATA(lt_sort_elements) = io_request->get_sort_elements( ) .
            DATA(lt_ranges) = io_request->get_filter( )->get_as_ranges( )."Basic search term
            DATA(lt_filter_cond) = io_request->get_parameters( ). "setting the filter condition, fetching parameter names from data definition

            LOOP AT lt_ranges REFERENCE INTO DATA(lr_range).
              CASE lr_range->name.
                WHEN 'PLANT'.
                  LOOP AT lr_range->range REFERENCE INTO DATA(lr_range_entry).
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE RT_plant.
                  ENDLOOP.
                WHEN 'PRODUCT'.
                  LOOP AT lr_range->range REFERENCE INTO lr_range_entry.
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE rt_product.
                  ENDLOOP.
                WHEN 'SoldToParty'.
                  LOOP AT lr_range->range REFERENCE INTO lr_range_entry.
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE rt_SoldToParty.
                  ENDLOOP.
              ENDCASE.
            ENDLOOP.

            DATA:lt_table     TYPE STANDARD TABLE OF zcv_kcbb_sum,
                 lt_table_out TYPE STANDARD TABLE OF zcv_kcbb_sum,
                 ls_table     TYPE zcv_kcbb_sum.
            TRY.
*                SELECT
*                      a~product,
*                     a~Plant,
*                     OrderQuantityUnit,
*                     SUM( OrderQuantity ) AS OrderQuantity,
*                     SUM( ActualDeliveryQuantity ) AS DNQuantity,
*                     SUM( OrderQuantity ) - SUM( ActualDeliveryQuantity ) AS wfhquantity
*                FROM I_SlsOrdConfAnalyticsCube( P_ExchangeRateType = 'M', P_DisplayCurrency = 'CNY' ) AS a
*                JOIN I_DeliveryDocumentItem AS b ON a~SalesOrder = b~referencesddocument AND a~salesorderitem = b~ReferenceSDDocumentItem
*                WHERE a~product IN @rt_product
*                AND a~plant IN @rt_plant
*                AND a~SoldToParty IN @rt_soldtoparty
*                GROUP BY a~product,a~Plant,OrderQuantityUnit
*                INTO CORRESPONDING FIELDS OF TABLE @lt_table.
                "取出基本数据
                SELECT
                     product,
                     Plant,
                     OrderQuantityUnit AS MaterialBaseUnit,
                     SUM( OrderQuantity ) AS xmzQuantity
                FROM I_SlsOrdConfAnalyticsCube( P_ExchangeRateType = 'M', P_DisplayCurrency = 'CNY' )
                WHERE product IN @rt_product
                AND plant IN @rt_plant
                AND SoldToParty IN @rt_soldtoparty
                AND SalesOrderType IN ( 'CCFU','CBFD' )
                GROUP BY product,Plant,OrderQuantityUnit
                INTO TABLE @DATA(lt_SOQUAN).

                SELECT
                     a~product,
                     a~Plant,
                     OrderQuantityUnit,
                     SUM( ActualDeliveryQuantity ) AS ActualDeliveryQuantity
                FROM I_SlsOrdConfAnalyticsCube( P_ExchangeRateType = 'M', P_DisplayCurrency = 'CNY' ) AS a
                JOIN I_DeliveryDocumentItem AS b ON a~SalesOrder = b~referencesddocument AND a~salesorderitem = b~ReferenceSDDocumentItem
                WHERE a~product IN @rt_product
                AND a~plant IN @rt_plant
                AND a~SoldToParty IN @rt_soldtoparty
                AND SalesOrderType IN ( 'CCFU','CBFD' )
                GROUP BY a~product,a~Plant,OrderQuantityUnit
                INTO TABLE @DATA(lt_DNQUAN).
                SORT lt_DNQUAN BY product plant.

                SELECT *
                  FROM I_StockQuantityCurrentValue_2( P_DisplayCurrency = 'CNY' )
                  WHERE product IN @rt_product
                  AND plant IN @rt_plant
                  INTO TABLE @DATA(lt_stock).

                IF lt_SOQUAN IS NOT INITIAL.
                  "--物料描述
                  SELECT *
                      FROM I_ProductDescription
                      FOR ALL ENTRIES IN @lt_SOQUAN
                      WHERE product = @lt_SOQUAN-product
                      AND Language EQ '1'
                      INTO TABLE @DATA(lt_makt).
                  SORT lt_makt BY product.
                ENDIF.
                "生产供应
                SELECT
                     product,
                     ProductionPlant AS Plant,
                     SUM( MfgOrderPlannedTotalQty ) - SUM( ActualDeliveredQuantity ) AS scQuantity
                FROM I_MfgOrderWithStatus
                WHERE product IN @rt_product
                AND ProductionPlant IN @rt_plant
                GROUP BY product,ProductionPlant
                INTO TABLE @DATA(lt_Scgy).
                SORT lt_Scgy BY product plant.
                "采购供应
                SELECT
                     Material AS product,
                     Plant,
                     SUM( ScheduleLineOrderQuantity ) - SUM( RoughGoodsReceiptQty ) AS cgQuantity
                FROM I_PurOrdScheduleLineAPI01 AS a
                JOIN I_PurchaseOrderItemAPI01 AS b ON a~PurchaseOrder = b~PurchaseOrder AND a~PurchaseOrderItem = b~PurchaseOrderItem
                WHERE Material IN @rt_product
                AND Plant IN @rt_plant
                GROUP BY Material,Plant
                INTO TABLE @DATA(lt_cggy).
                SORT lt_cggy BY product plant.

                LOOP AT lt_SOQUAN INTO DATA(ls_SOQUAN).
                  MOVE-CORRESPONDING ls_SOQUAN TO ls_table.
                  "--项目总需求
                  READ TABLE lt_DNQUAN INTO DATA(ls_dnquan) WITH KEY product = ls_SOQUAN-product plant = ls_SOQUAN-plant BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    ls_table-xmzQuantity = ls_table-xmzQuantity - ls_dnquan-actualdeliveryquantity.
                    CLEAR ls_dnquan.
                  ENDIF.
                  CHECK ls_table-xmzQuantity > 0.

                  "--生产供应
                  READ TABLE lt_Scgy INTO DATA(ls_Scgy) WITH KEY product = ls_SOQUAN-product plant = ls_SOQUAN-plant BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    ls_table-scQuantity = ls_Scgy-scQuantity.
                    CLEAR ls_Scgy.
                  ENDIF.
                  "--采购供应
                  READ TABLE lt_cggy INTO DATA(ls_cggy) WITH KEY product = ls_SOQUAN-product plant = ls_SOQUAN-plant BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    ls_table-cgQuantity = ls_cggy-cgQuantity.
                    CLEAR ls_cggy.
                  ENDIF.
                  LOOP AT lt_stock INTO DATA(ls_stock) WHERE product = ls_SOQUAN-product AND plant = ls_SOQUAN-plant.
                    "成品库存
                    IF ls_stock-ValuationAreaType EQ '1'
                    AND ls_stock-InventoryStockType EQ '01'
                    AND ls_stock-InventorySpecialStockType IS INITIAL
                    AND ( ls_stock-StorageLocation EQ 'L001' OR ls_stock-StorageLocation EQ 'L003' OR ls_stock-StorageLocation EQ 'L006' ).
                      ls_table-cpQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-cpQuantity.
                    ENDIF.
                    "未翻新库存
                    IF ls_stock-ValuationAreaType EQ '1'
                    AND ls_stock-InventoryStockType EQ '02'
                    AND ls_stock-InventorySpecialStockType IS INITIAL
                    AND ls_stock-StorageLocation EQ 'L002'.
                      ls_table-wfxQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-wfxQuantity.
                    ENDIF.
                    "质检库存
                    IF ls_stock-ValuationAreaType EQ '1'
                    AND ls_stock-InventoryStockType EQ '02'
                    AND ls_stock-InventorySpecialStockType IS INITIAL
                    AND ( ls_stock-StorageLocation EQ 'L001' OR ls_stock-StorageLocation EQ 'L003' OR ls_stock-StorageLocation EQ 'L006' ).
                      ls_table-zjQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-zjQuantity.
                    ENDIF.
                    "客户库存
                    IF ls_stock-ValuationAreaType EQ '1'
                    AND ls_stock-InventoryStockType EQ '01'
                    AND ls_stock-InventorySpecialStockType EQ 'W'.
                      ls_table-khQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-khQuantity.
                    ENDIF.
                    "委外库存
                    IF ls_stock-ValuationAreaType EQ '1'
                    AND ls_stock-InventoryStockType EQ '01'
                    AND ls_stock-InventorySpecialStockType EQ 'O'.
                      ls_table-wwQuantity = ls_stock-MatlWrhsStkQtyInMatlBaseUnit + ls_table-wwQuantity.
                    ENDIF.
                    CLEAR ls_stock.
                  ENDLOOP.
                  "-供需差额
                  ls_table-gxQuantity = ls_table-xmzQuantity - ls_table-cpQuantity + ls_table-zjQuantity + ls_table-khQuantity + ls_table-wwQuantity.
                  "-物料描述
                  READ TABLE lt_makt INTO DATA(ls_makt) WITH KEY product = ls_SOQUAN-product BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    ls_table-maktx = ls_makt-ProductDescription.
                    CLEAR ls_makt.
                  ENDIF.
                  APPEND ls_table TO lt_table.
                  CLEAR:ls_SOQUAN,ls_table.
                ENDLOOP.
              CATCH cx_sy_dynamic_osql_syntax INTO DATA(lx_data). " exception to catch and manage dynamic query errors . must use this in order to work properly
            ENDTRY.
            "lo_response->get_business_data( IMPORTING et_business_data = lt_table ).
*            DATA lv_lines TYPE int8.
*            lv_lines = lines( lt_table ).
            DATA(lv_start) = lv_skip + 1.
            IF lv_top <= 0.
              lv_top = 50.
            ENDIF.
            DATA(lv_end) = lv_skip + lv_top.

            APPEND LINES OF lt_table FROM lv_start TO lv_end TO lt_table_out.

            io_response->set_total_number_of_records( lines( lt_table ) ).
            io_response->set_data( lt_table_out ).
            "io_response->set_total_number_of_records( lines( lt_table  ) ).
            "ENDIF.
          CATCH  cx_rap_query_provider INTO DATA(lx_exc).
        ENDTRY.
      CATCH cx_rfc_dest_provider_error INTO DATA(lx_dest).
    ENDTRY.
  ENDMETHOD.
ENDCLASS.
