CLASS zcl_material_stock_sx DEFINITION
  PUBLIC
  FINAL
  CREATE PUBLIC .

  PUBLIC SECTION.
    INTERFACES if_rap_query_provider.
  PROTECTED SECTION.
  PRIVATE SECTION.
ENDCLASS.



CLASS ZCL_MATERIAL_STOCK_SX IMPLEMENTATION.


  METHOD if_rap_query_provider~select.
    TRY.
        TRY.
            "IF io_request->is_data_requested(  ).
            "io_request->get_paging( ).
            DATA: rt_plant   TYPE RANGE OF werks_D,
                  rt_product TYPE RANGE OF matnr.
            DATA(lo_paging) = io_request->get_paging( ).
            DATA(lv_skip) = io_request->get_paging( )->get_offset(  ).
            DATA(lv_top) = io_request->get_paging( )->get_page_size(  ).
            DATA(lt_sort_elements) = io_request->get_sort_elements( ) .
            DATA(lt_ranges) = io_request->get_filter( )->get_as_ranges( )."Basic search term
            DATA(lt_filter_cond) = io_request->get_parameters( ). "setting the filter condition, fetching parameter names from data definition

            LOOP AT lt_ranges REFERENCE INTO DATA(lr_range).
              CASE lr_range->name.
                WHEN 'PLANT'.
                  LOOP AT lr_range->range REFERENCE INTO DATA(lr_range_entry).
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE RT_plant.
                  ENDLOOP.
                WHEN 'PRODUCT'.
                  LOOP AT lr_range->range REFERENCE INTO lr_range_entry.
                    INSERT VALUE #( sign = lr_range_entry->sign option =  lr_range_entry->option
                                    low  = CONV #( lr_range_entry->low )  high   = CONV #( lr_range_entry->high ) )
                                    INTO TABLE rt_product.
                  ENDLOOP.
              ENDCASE.
            ENDLOOP.

            DATA:lt_table     TYPE STANDARD TABLE OF zcv_xskc,
                 lt_table_out TYPE STANDARD TABLE OF zcv_xskc.
            TRY.
                SELECT
                      a~product,
                     SoldToPartyName,
                     a~Plant,
                     OrderQuantityUnit,
                     SUM( OrderQuantity ) AS OrderQuantity,
                     SUM( ActualDeliveryQuantity ) AS DNQuantity,
                     SUM( OrderQuantity ) - SUM( ActualDeliveryQuantity ) AS wfhquantity
                FROM I_SlsOrdConfAnalyticsCube( P_ExchangeRateType = 'M', P_DisplayCurrency = 'CNY' ) AS a
                JOIN I_DeliveryDocumentItem AS b ON a~SalesOrder = b~referencesddocument AND a~salesorderitem = b~ReferenceSDDocumentItem
                WHERE a~product IN @rt_product
                AND a~plant IN @rt_plant
                AND SalesOrderType IN ( 'CCFU','CBFD' )
                GROUP BY a~product,a~SoldToPartyName,a~Plant,OrderQuantityUnit
                INTO CORRESPONDING FIELDS OF TABLE @lt_table.
                DELETE lt_table WHERE wfhquantity = 0.
                IF lt_table IS NOT INITIAL.
                  SELECT *
                  FROM I_ProductDescription
                  FOR ALL ENTRIES IN @lt_table
                  WHERE product = @lt_table-product
                  AND Language EQ '1'
                  INTO TABLE @DATA(lt_makt).
                  SORT lt_makt BY product.
                ENDIF.
                LOOP AT lt_table INTO DATA(ls_data).
                  "-未发货数量
                  ls_data-WFHQuantity = ls_data-OrderQuantity - ls_data-DNQuantity.
                  "-物料描述
                  READ TABLE lt_makt INTO DATA(ls_makt) WITH KEY product = ls_data-product BINARY SEARCH.
                  IF sy-subrc EQ 0.
                    ls_data-maktx = ls_makt-ProductDescription.
                    CLEAR ls_makt.
                  ENDIF.
                  MODIFY lt_table FROM ls_data.
                  CLEAR ls_data.
                ENDLOOP.

                SORT lt_table BY product.
              CATCH cx_sy_dynamic_osql_syntax INTO DATA(lx_data). " exception to catch and manage dynamic query errors . must use this in order to work properly
            ENDTRY.
            DATA(lv_start) = lv_skip + 1.
            IF lv_top <= 0.
              lv_top = 50.
            ENDIF.
            DATA(lv_end) = lv_skip + lv_top.

            APPEND LINES OF lt_table FROM lv_start TO lv_end TO lt_table_out.

            io_response->set_total_number_of_records( lines( lt_table  ) ).
            io_response->set_data( lt_table ).
            "io_response->set_total_number_of_records( lines( lt_table  ) ).
            "ENDIF.
          CATCH  cx_rap_query_provider INTO DATA(lx_exc).
        ENDTRY.
      CATCH cx_rfc_dest_provider_error INTO DATA(lx_dest).
    ENDTRY.
  ENDMETHOD.
ENDCLASS.
