@AccessControl.authorizationCheck: #NOT_REQUIRED
@EndUserText.label: '库存报表-采购库存'
define root view entity ZCV_CGKC as select from I_PurchaseOrderItemAPI01 as a
association [1] to I_ProductDescription as b 
on b.Language = '1' and $projection.Material = b.Product
association [0..1] to I_PurOrdScheduleLineAPI01 as c
on $projection.PurchaseOrder = c.PurchaseOrder and $projection.PurchaseOrderItem = c.PurchaseOrderItem
association [0..1] to ZCV_SUPName as d
on $projection.PurchaseOrder = d.PurchaseOrder
{
//采购订单
    key a.PurchaseOrder as PurchaseOrder,
//采购订单行    
     key a.PurchaseOrderItem,
//物料号    
    a.Material,
    @Consumption.valueHelpDefinition: [
        { entity:  { name:    'I_ProductstdVH',
                     element: 'Product' }
        }]
    b.Product as Product,
//物料描述
    b.ProductDescription,
//工厂
    @Consumption.valueHelpDefinition: [
        { entity:  { name:    'I_PlantstdVH',
                     element: 'Plant' }
        }]
    a.Plant,
//采购订单日期
    d.CreationDate,
//采购订单数量
    cast( c.RoughGoodsReceiptQty as abap.char( 20 ) )  as Zcgsl,
//供应商名称
    d.Supplier,
//供应商描述
//    cast( e.SupplierName as abap.char( 20 ) ) as SupplierName,
    d.SupplierName,
//到货日期
    c.ScheduleLineDeliveryDate,
//采购订单未收货数量
    cast( ( c.ScheduleLineOrderQuantity - c.RoughGoodsReceiptQty ) as abap.char( 20 ) )  as Zwshsl,
//单位
    PurchaseOrderQuantityUnit,
    /* Associations */
    _PurchaseOrder
}where b.Product is not initial
and c.ScheduleLineOrderQuantity <> c.RoughGoodsReceiptQty
